module     p0_udbar_neepbbbar_d1h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity0/d1h0l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d1
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd1h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t2 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t3 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t4 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t40 = dotproduct(qshift, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t41 = dotproduct(k3, qshift)
      t42 = dotproduct(k4, qshift)
      t43 = dotproduct(l5, qshift)
      t44 = dotproduct(l6, qshift)
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t45 = dotproduct(k2, qshift)
      t7 = (spval5k2(1)*qshift(1)-spval5k2(2)*qshift(2)-spval5k2(3)*qshift(3)-sp&
      &val5k2(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb1n107+t2*abb1n108+t3*abb1n109+t4*abb1n37+t40*abb1n55&
         &+t41*abb1n88+t42*abb1n88+t43*abb1n89+t44*abb1n89+t45*abb1n91+t5*abb1n7&
         &3+t6*abb1n90+t7*abb1n92+t1*t8*abb1n42+t2*t40*abb1n104+t2*t41*abb1n50+t&
         &2*t42*abb1n50+t2*t8*abb1n39+t3*t40*abb1n100+t3*t41*abb1n52+t3*t42*abb1&
         &n52+t3*t8*abb1n41+t4*t40*abb1n85+t4*t41*abb1n63+t4*t42*abb1n63+t4*t6*a&
         &bb1n56+t4*t8*abb1n53+t40*t5*abb1n111+t40*t7*abb1n81+t40*t8*abb1n76+t41&
         &*t7*abb1n65+t41*t8*abb1n68+t42*t7*abb1n65+t42*t8*abb1n68+t43*t8*abb1n7&
         &0+t44*t8*abb1n70+t45*t8*abb1n67+t5*t8*abb1n48+t6*t7*abb1n57+t7*t8*abb1&
         &n54+t8*t9*abb1n43+t1*t4*t8*abb1n118+t1*t7*t8*abb1n116)
         return
      end if
      t10 = k2(iv1)
      t11 = k3(iv1)
      t12 = k4(iv1)
      t13 = l5(iv1)
      t14 = l6(iv1)
      t15 = qshift(iv1)
      t16 = spvak2k1(iv1)
      t17 = spvak2k4(iv1)
      t18 = spvak3k1(iv1)
      t19 = spval5k1(iv1)
      t20 = spval5k2(iv1)
      t21 = spval6k1(iv1)
      t22 = spval6k2(iv1)
      t23 = spvak3k4(iv1)
      t24 = t23*abb1n74
      t25 = t23*abb1n78
      t26 = spvak4k1(iv1)
      t27 = t19*abb1n98
      t28 = t20*abb1n83
      t29 = t21*abb1n102
      t30 = t22*abb1n87
      if(deg.eq.1) then
         numerator = (t10*abb1n59+t11*abb1n62+t12*abb1n62+t13*abb1n61+t14*abb1n6&
         &1+t15*abb1n95+t16*abb1n47+t17*abb1n60+t18*abb1n71+t19*abb1n45+t20*abb1&
         &n58+t21*abb1n46+t22*abb1n72+t24*t43+t24*t44+t25*t41+t25*t42+t27*t41+t2&
         &7*t42+t28*t41+t28*t42+t29*t41+t29*t42+t30*t41+t30*t42+t1*t23*abb1n114+&
         &t10*t8*abb1n79+t11*t2*abb1n102+t11*t3*abb1n98+t11*t4*abb1n87+t11*t7*ab&
         &b1n83+t11*t8*abb1n78+t12*t2*abb1n102+t12*t3*abb1n98+t12*t4*abb1n87+t12&
         &*t7*abb1n83+t12*t8*abb1n78+t13*t8*abb1n74+t14*t8*abb1n74+t15*t2*abb1n1&
         &03+t15*t3*abb1n99+t15*t4*abb1n84+t15*t5*abb1n110+t15*t7*abb1n80+t15*t8&
         &*abb1n75+t16*t8*abb1n114+t17*t4*abb1n94+t17*t7*abb1n93+t18*t40*abb1n44&
         &+t18*t8*abb1n106+t19*t40*abb1n51+t19*t8*abb1n115+t2*t23*abb1n117+t20*t&
         &40*abb1n66+t20*t6*abb1n93+t20*t8*abb1n96+t21*t40*abb1n49+t21*t8*abb1n1&
         &17+t22*t40*abb1n64+t22*t6*abb1n94+t22*t8*abb1n97+t23*t3*abb1n115+t23*t&
         &4*abb1n97+t23*t40*abb1n69+t23*t45*abb1n79+t23*t5*abb1n106+t23*t7*abb1n&
         &96+t23*t9*abb1n113+t26*t8*abb1n113+t1*t20*t8*abb1n40+t1*t22*t8*abb1n38&
         &+t1*t23*t4*abb1n38+t1*t23*t7*abb1n40+t16*t4*t8*abb1n38+t16*t7*t8*abb1n&
         &40)
         return
      end if
      t40 = d(iv1,iv2)
      t6 = spvak3k4(iv2)
      t9 = spval5k1(iv2)
      t24 = spval5k2(iv2)
      t25 = spval6k1(iv2)
      t27 = spval6k2(iv2)
      t28 = k3(iv2)
      t29 = k4(iv2)
      t30 = spvak3k1(iv2)
      t31 = qshift(iv2)
      t32 = t16*t6
      t33 = spvak2k1(iv2)
      t34 = t23*t33
      t35 = spvak2k4(iv2)
      t36 = t23*t24
      t37 = t23*t27
      t38 = t20*t6
      t39 = t22*t6
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t40*abb1n55+t2*t40*abb1n104+t3*t40*abb1n100+t4*t&
         &40*abb1n85+t40*t5*abb1n111+t40*t7*abb1n81+t40*t8*abb1n76)+t32*abb1n42+&
         &t34*abb1n42+t36*abb1n54+t37*abb1n53+t38*abb1n54+t39*abb1n53+k2(iv2)*t2&
         &3*abb1n67+l5(iv2)*t23*abb1n70+l6(iv2)*t23*abb1n70+spvak4k1(iv2)*t23*ab&
         &b1n43+t1*t36*abb1n116+t1*t37*abb1n118+t1*t38*abb1n116+t1*t39*abb1n118+&
         &t10*t6*abb1n67+t11*t24*abb1n65+t11*t25*abb1n50+t11*t27*abb1n63+t11*t6*&
         &abb1n68+t11*t9*abb1n52+t12*t24*abb1n65+t12*t25*abb1n50+t12*t27*abb1n63&
         &+t12*t6*abb1n68+t12*t9*abb1n52+t13*t6*abb1n70+t14*t6*abb1n70+t15*t24*a&
         &bb1n82+t15*t25*abb1n105+t15*t27*abb1n86+t15*t30*abb1n112+t15*t6*abb1n7&
         &7+t15*t9*abb1n101+t17*t24*abb1n57+t17*t27*abb1n56+t18*t31*abb1n112+t18&
         &*t6*abb1n48+t19*t28*abb1n52+t19*t29*abb1n52+t19*t31*abb1n101+t19*t6*ab&
         &b1n41+t20*t28*abb1n65+t20*t29*abb1n65+t20*t31*abb1n82+t20*t35*abb1n57+&
         &t21*t28*abb1n50+t21*t29*abb1n50+t21*t31*abb1n105+t21*t6*abb1n39+t22*t2&
         &8*abb1n63+t22*t29*abb1n63+t22*t31*abb1n86+t22*t35*abb1n56+t23*t25*abb1&
         &n39+t23*t28*abb1n68+t23*t29*abb1n68+t23*t30*abb1n48+t23*t31*abb1n77+t2&
         &3*t9*abb1n41+t26*t6*abb1n43+t32*t4*abb1n118+t32*t7*abb1n116+t34*t4*abb&
         &1n118+t34*t7*abb1n116+t16*t24*t8*abb1n116+t16*t27*t8*abb1n118+t20*t33*&
         &t8*abb1n116+t22*t33*t8*abb1n118)
         return
      end if
      t41 = d(iv2,iv3)
      t42 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spval5k2(iv3)
      t3 = spval6k2(iv3)
      t4 = t1*t16
      t5 = t1*t33
      t7 = spvak2k1(iv3)
      t8 = t23*t7
      t7 = t6*t7
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t40*abb1n44+spval5k1(iv3)*t40*abb1&
         &n51+spval6k1(iv3)*t40*abb1n49+t1*t40*abb1n69+t18*t41*abb1n44+t19*t41*a&
         &bb1n51+t2*t40*abb1n66+t20*t41*abb1n66+t21*t41*abb1n49+t22*t41*abb1n64+&
         &t23*t41*abb1n69+t24*t42*abb1n66+t25*t42*abb1n49+t27*t42*abb1n64+t3*t40&
         &*abb1n64+t30*t42*abb1n44+t42*t6*abb1n69+t42*t9*abb1n51)+t2*t32*abb1n40&
         &+t2*t34*abb1n40+t20*t5*abb1n40+t20*t7*abb1n40+t22*t5*abb1n38+t22*t7*ab&
         &b1n38+t24*t4*abb1n40+t24*t8*abb1n40+t27*t4*abb1n38+t27*t8*abb1n38+t3*t&
         &32*abb1n38+t3*t34*abb1n38)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d1:
   subroutine     reconstruct_d1(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_1:
      coeffs%coeffs_1%c0 = derivative(czip)
      coeffs%coeffs_1%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_1%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_1%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_1%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_1%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_1%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_1%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_1%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_1%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_1%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_1%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_1%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_1%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_1%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_1%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_1%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_1%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_1%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_1%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_1%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_1%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_1%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_1%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_1%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_1%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_1%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_1%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_1%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_1:
   end subroutine reconstruct_d1
!---#] subroutine reconstruct_d1:
end module p0_udbar_neepbbbar_d1h0l1d
