module     p0_udbar_neepbbbar_d8h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity0/d8h0l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d8
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd8h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      real(ki) :: t25
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t3 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t4 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t5 = (spval5k2(1)*qshift(1)-spval5k2(2)*qshift(2)-spval5k2(3)*qshift(3)-sp&
      &val5k2(4)*qshift(4))
      t22 = dotproduct(k2, qshift)
      t6 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      t23 = dotproduct(l5, qshift)
      t24 = dotproduct(l6, qshift)
      t25 = dotproduct(k1, qshift)
      t7 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t8 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb8n17+abb8n27*dotproduct(qshift, qshift)+abb8n29*dotp&
         &roduct(k3, qshift)+abb8n29*dotproduct(k4, qshift)+abb8n31*(spvak2k4(1)&
         &*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qsh&
         &ift(4))+t1*t2*abb8n18+t1*t22*abb8n22+t1*t23*abb8n24+t1*t24*abb8n24+t1*&
         &t25*abb8n25+t1*t3*abb8n19+t1*t4*abb8n20+t1*t5*abb8n21+t1*t6*abb8n23+t1&
         &*t7*abb8n26+t1*t8*abb8n28)
         return
      end if
      t9 = spvak3k4(iv1)
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = l5(iv1)
      t13 = l6(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak2l5(iv1)
      t16 = spvak2l6(iv1)
      t17 = t9*abb8n24
      t18 = spval5k1(iv1)
      t19 = spval5k2(iv1)
      t20 = spval6k1(iv1)
      t21 = spval6k2(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb8n29+k4(iv1)*abb8n29+qshift(iv1)*abb8n30+spvak2&
         &k4(iv1)*abb8n31+t17*t23+t17*t24+t9*abb8n17+t1*t10*abb8n25+t1*t11*abb8n&
         &22+t1*t12*abb8n24+t1*t13*abb8n24+t1*t14*abb8n28+t1*t15*abb8n23+t1*t16*&
         &abb8n26+t1*t18*abb8n19+t1*t19*abb8n21+t1*t20*abb8n18+t1*t21*abb8n20+t2&
         &*t9*abb8n18+t22*t9*abb8n22+t25*t9*abb8n25+t3*t9*abb8n19+t4*t9*abb8n20+&
         &t5*t9*abb8n21+t6*t9*abb8n23+t7*t9*abb8n26+t8*t9*abb8n28)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb8n27+k1(iv2)*t9*abb8n25+k2(iv2)*t9*&
         &abb8n22+l5(iv2)*t9*abb8n24+l6(iv2)*t9*abb8n24+spvak2k1(iv2)*t9*abb8n28&
         &+spvak2l5(iv2)*t9*abb8n23+spvak2l6(iv2)*t9*abb8n26+spval5k1(iv2)*t9*ab&
         &b8n19+spval5k2(iv2)*t9*abb8n21+spval6k1(iv2)*t9*abb8n18+spval6k2(iv2)*&
         &t9*abb8n20+t1*t10*abb8n25+t1*t11*abb8n22+t1*t12*abb8n24+t1*t13*abb8n24&
         &+t1*t14*abb8n28+t1*t15*abb8n23+t1*t16*abb8n26+t1*t18*abb8n19+t1*t19*ab&
         &b8n21+t1*t20*abb8n18+t1*t21*abb8n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d8:
   subroutine     reconstruct_d8(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_8:
      coeffs%coeffs_8%c0 = derivative(czip)
      coeffs%coeffs_8%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_8%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_8%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_8%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_8%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_8%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_8%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_8%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_8%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_8%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_8%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_8%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_8%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_8%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_8:
   end subroutine reconstruct_d8
!---#] subroutine reconstruct_d8:
end module p0_udbar_neepbbbar_d8h0l1d
