module     p0_udbar_neepbbbar_d24h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity1/d24h1l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd24h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      real(ki) :: t50
      real(ki) :: t51
      real(ki) :: t52
      real(ki) :: t53
      real(ki) :: t54
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t50 = dotproduct(l6, qshift)
      t1 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t51 = dotproduct(k2, qshift)
      t52 = dotproduct(qshift, qshift)
      t53 = dotproduct(k1, qshift)
      t54 = dotproduct(l5, qshift)
      t2 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t6 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t9 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t10 = (spval6k4(1)*qshift(1)-spval6k4(2)*qshift(2)-spval6k4(3)*qshift(3)-s&
      &pval6k4(4)*qshift(4))
      t11 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-s&
      &pval6l5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb24n53+t1*abb24n102+t2*abb24n88+t3*abb24n89+t4*abb24n90+&
         &t5*abb24n91+t50*abb24n101+t51*abb24n105+t51*t51*abb24n79+t52*abb24n84+&
         &t53*abb24n85+t54*abb24n87+t6*abb24n92+t7*abb24n93+t8*abb24n94+t9*abb24&
         &n98+t1*t11*abb24n77+t1*t6*abb24n56+t1*t7*abb24n58+t10*t2*abb24n71+t10*&
         &t51*abb24n73+t10*t52*abb24n99+t10*t53*abb24n74+t10*t54*abb24n75+t10*t7&
         &*abb24n61+t11*t3*abb24n72+t11*t4*abb24n70+t11*t51*abb24n82+t2*t3*abb24&
         &n67+t2*t50*abb24n78+t2*t9*abb24n81+t3*t51*abb24n66+t3*t6*abb24n83+t3*t&
         &7*abb24n76+t4*t51*abb24n65+t4*t52*abb24n103+t4*t53*abb24n68+t4*t54*abb&
         &24n69+t4*t6*abb24n62+t4*t7*abb24n55+t5*t51*abb24n60+t50*t7*abb24n57+t5&
         &1*t52*abb24n95+t51*t54*abb24n80+t51*t6*abb24n59+t51*t7*abb24n64+t51*t8&
         &*abb24n54+t7*t9*abb24n63+t11*t3*t7*abb24n107+t2*t3*t6*abb24n106+t3*t51&
         &*t7*abb24n108)
         return
      end if
      t12 = k1(iv1)
      t13 = k2(iv1)
      t14 = l5(iv1)
      t15 = l6(iv1)
      t16 = qshift(iv1)
      t17 = spvak2k1(iv1)
      t18 = spvak2k4(iv1)
      t19 = spvak2l5(iv1)
      t20 = spvak2l6(iv1)
      t21 = spvak3k1(iv1)
      t22 = spvak3k4(iv1)
      t23 = spval5k1(iv1)
      t24 = spval6k1(iv1)
      t25 = spval6k2(iv1)
      t26 = spval6k4(iv1)
      t27 = spval6l5(iv1)
      if(deg.eq.1) then
         numerator = (t12*abb24n85+t13*abb24n105+t14*abb24n87+t15*abb24n101+t16*&
         &abb24n86+t17*abb24n93+t18*abb24n90+t19*abb24n88+t20*abb24n102+t21*abb2&
         &4n94+t22*abb24n89+t23*abb24n91+t24*abb24n92+t25*abb24n98+t1*t17*abb24n&
         &58+t1*t24*abb24n56+t1*t27*abb24n77+t10*t12*abb24n74+t10*t13*abb24n73+t&
         &10*t14*abb24n75+t10*t16*abb24n100+t10*t17*abb24n61+t10*t19*abb24n71+t1&
         &1*t13*abb24n82+t11*t18*abb24n70+t11*t20*abb24n77+t11*t22*abb24n72+t12*&
         &t4*abb24n68+t13*t3*abb24n66+t13*t4*abb24n65+t13*t5*abb24n60+t13*t51*ab&
         &b24n97+t13*t52*abb24n95+t13*t54*abb24n80+t13*t6*abb24n59+t13*t7*abb24n&
         &64+t13*t8*abb24n54+t14*t4*abb24n69+t14*t51*abb24n80+t15*t2*abb24n78+t1&
         &5*t7*abb24n57+t16*t4*abb24n104+t16*t51*abb24n96+t17*t3*abb24n76+t17*t4&
         &*abb24n55+t17*t50*abb24n57+t17*t51*abb24n64+t17*t9*abb24n63+t18*t51*ab&
         &b24n65+t18*t52*abb24n103+t18*t53*abb24n68+t18*t54*abb24n69+t18*t6*abb2&
         &4n62+t18*t7*abb24n55+t19*t3*abb24n67+t19*t50*abb24n78+t19*t9*abb24n81+&
         &t2*t22*abb24n67+t2*t25*abb24n81+t2*t26*abb24n71+t20*t6*abb24n56+t20*t7&
         &*abb24n58+t21*t51*abb24n54+t22*t51*abb24n66+t22*t6*abb24n83+t22*t7*abb&
         &24n76+t23*t51*abb24n60+t24*t3*abb24n83+t24*t4*abb24n62+t24*t51*abb24n5&
         &9+t25*t7*abb24n63+t26*t51*abb24n73+t26*t52*abb24n99+t26*t53*abb24n74+t&
         &26*t54*abb24n75+t26*t7*abb24n61+t27*t3*abb24n72+t27*t4*abb24n70+t27*t5&
         &1*abb24n82+t11*t17*t3*abb24n107+t11*t22*t7*abb24n107+t13*t3*t7*abb24n1&
         &08+t17*t3*t51*abb24n108+t19*t3*t6*abb24n106+t2*t22*t6*abb24n106+t2*t24&
         &*t3*abb24n106+t22*t51*t7*abb24n108+t27*t3*t7*abb24n107)
         return
      end if
      t50 = d(iv1,iv2)
      t1 = k2(iv2)
      t5 = spvak2k4(iv2)
      t8 = spval6k4(iv2)
      t9 = k1(iv2)
      t28 = l5(iv2)
      t29 = qshift(iv2)
      t30 = spvak2k1(iv2)
      t31 = t13*t30
      t32 = spvak3k4(iv2)
      t33 = t13*t32
      t34 = spval6k1(iv2)
      t35 = spval6l5(iv2)
      t36 = t1*t17
      t37 = t1*t22
      t38 = spvak2l5(iv2)
      t39 = l6(iv2)
      t40 = spvak2l6(iv2)
      t41 = t17*t32
      t42 = spval6k2(iv2)
      t43 = t22*t30
      t44 = t19*t32
      t45 = t22*t38
      t46 = t22*t34
      t47 = t22*t35
      t48 = t24*t32
      t49 = t27*t32
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t50*abb24n84+t1*t13*abb24n79+t10*t50*abb24n99+t4&
         &*t50*abb24n103+t50*t51*abb24n95)+t31*abb24n64+t33*abb24n66+t36*abb24n6&
         &4+t37*abb24n66+t41*abb24n76+t43*abb24n76+t44*abb24n67+t45*abb24n67+t46&
         &*abb24n83+t47*abb24n72+t48*abb24n83+t49*abb24n72+spvak3k1(iv2)*t13*abb&
         &24n54+spval5k1(iv2)*t13*abb24n60+t1*t14*abb24n80+t1*t16*abb24n96+t1*t1&
         &8*abb24n65+t1*t21*abb24n54+t1*t23*abb24n60+t1*t24*abb24n59+t1*t26*abb2&
         &4n73+t1*t27*abb24n82+t11*t41*abb24n107+t11*t43*abb24n107+t12*t5*abb24n&
         &68+t12*t8*abb24n74+t13*t28*abb24n80+t13*t29*abb24n96+t13*t34*abb24n59+&
         &t13*t35*abb24n82+t13*t5*abb24n65+t13*t8*abb24n73+t14*t5*abb24n69+t14*t&
         &8*abb24n75+t15*t30*abb24n57+t15*t38*abb24n78+t16*t5*abb24n104+t16*t8*a&
         &bb24n100+t17*t39*abb24n57+t17*t40*abb24n58+t17*t42*abb24n63+t17*t5*abb&
         &24n55+t17*t8*abb24n61+t18*t28*abb24n69+t18*t29*abb24n104+t18*t30*abb24&
         &n55+t18*t34*abb24n62+t18*t35*abb24n70+t18*t9*abb24n68+t19*t39*abb24n78&
         &+t19*t42*abb24n81+t19*t8*abb24n71+t2*t46*abb24n106+t2*t48*abb24n106+t2&
         &0*t30*abb24n58+t20*t34*abb24n56+t20*t35*abb24n77+t24*t40*abb24n56+t24*&
         &t5*abb24n62+t25*t30*abb24n63+t25*t38*abb24n81+t26*t28*abb24n75+t26*t29&
         &*abb24n100+t26*t30*abb24n61+t26*t38*abb24n71+t26*t9*abb24n74+t27*t40*a&
         &bb24n77+t27*t5*abb24n70+t3*t31*abb24n108+t3*t36*abb24n108+t33*t7*abb24&
         &n108+t37*t7*abb24n108+t41*t51*abb24n108+t43*t51*abb24n108+t44*t6*abb24&
         &n106+t45*t6*abb24n106+t47*t7*abb24n107+t49*t7*abb24n107+t17*t3*t35*abb&
         &24n107+t19*t3*t34*abb24n106+t24*t3*t38*abb24n106+t27*t3*t30*abb24n107)
         return
      end if
      t51 = d(iv2,iv3)
      t52 = d(iv1,iv3)
      t2 = k2(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak2k1(iv3)
      t6 = spval6l5(iv3)
      t7 = spval6k1(iv3)
      t9 = spvak2l5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t50*abb24n103+spval6k4(iv3)*t50*ab&
         &b24n99+t1*t52*abb24n95+t13*t51*abb24n95+t18*t51*abb24n103+t2*t50*abb24&
         &n95+t26*t51*abb24n99+t5*t52*abb24n103+t52*t8*abb24n99)+t3*t31*abb24n10&
         &8+t3*t36*abb24n108+t41*t6*abb24n107+t43*t6*abb24n107+t44*t7*abb24n106+&
         &t45*t7*abb24n106+t1*t22*t4*abb24n108+t13*t32*t4*abb24n108+t17*t2*t32*a&
         &bb24n108+t17*t3*t35*abb24n107+t19*t3*t34*abb24n106+t2*t22*t30*abb24n10&
         &8+t22*t34*t9*abb24n106+t22*t35*t4*abb24n107+t24*t3*t38*abb24n106+t24*t&
         &32*t9*abb24n106+t27*t3*t30*abb24n107+t27*t32*t4*abb24n107)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p0_udbar_neepbbbar_d24h1l1d
