module     p0_udbar_neepbbbar_abbrevd3h3
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_globalsh3
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: abb3n2
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki), public :: abb3n5
   complex(ki), public :: abb3n6
   complex(ki), public :: abb3n7
   complex(ki), public :: abb3n8
   complex(ki), public :: abb3n9
   complex(ki), public :: abb3n10
   complex(ki), public :: abb3n11
   complex(ki), public :: abb3n12
   complex(ki), public :: abb3n13
   complex(ki), public :: abb3n14
   complex(ki), public :: abb3n15
   complex(ki), public :: abb3n16
   complex(ki), public :: abb3n17
   complex(ki), public :: abb3n18
   complex(ki), public :: abb3n19
   complex(ki), public :: abb3n20
   complex(ki), public :: abb3n21
   complex(ki), public :: abb3n22
   complex(ki), public :: abb3n23
   complex(ki), public :: abb3n24
   complex(ki), public :: abb3n25
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n27
   complex(ki), public :: abb3n28
   complex(ki), public :: abb3n29
   complex(ki), public :: abb3n30
   complex(ki), public :: abb3n31
   complex(ki), public :: abb3n32
   complex(ki), public :: abb3n33
   complex(ki), public :: abb3n34
   complex(ki), public :: abb3n35
   complex(ki), public :: abb3n36
   complex(ki), public :: abb3n37
   complex(ki), public :: abb3n38
   complex(ki), public :: abb3n39
   complex(ki), public :: abb3n40
   complex(ki), public :: abb3n41
   complex(ki), public :: abb3n42
   complex(ki), public :: abb3n43
   complex(ki), public :: abb3n44
   complex(ki), public :: abb3n45
   complex(ki), public :: abb3n46
   complex(ki), public :: abb3n47
   complex(ki), public :: abb3n48
   complex(ki), public :: abb3n49
   complex(ki), public :: abb3n50
   complex(ki), public :: abb3n51
   complex(ki), public :: abb3n52
   complex(ki), public :: abb3n53
   complex(ki), public :: abb3n54
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   real(ki) :: t26
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_udbar_neepbbbar_config, only: deltaOS
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_model
      use p0_udbar_neepbbbar_color, only: TR
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = mB*es12*c1*i_
      t3 = t2*spbk4k3
      t4 = TR*spak2k3
      t4 = t4*t4
      t5 = es56*t1
      t26 = NC*NC
      t6 = t26*t5*spak2l5
      t5 = t26*t5*spak2l6
      t7 = mB*es12*c2*i_
      t8 = t7*spbk4k3
      t1 = es56*NC*t1
      t9 = t1*spak2l5
      t1 = t1*spak2l6
      abb3n1 = ((4.0_ki)*(t3*t4/t5*spbl5k1+t3*t4/t6*spbl6k1-(t4*t8/t9*spbl6k1+t4&
      &/t1*t8*spbl5k1)))
      t3 = mB*c1*i_
      t8 = t3*spak1k2
      t10 = t8*spak3k4
      t11 = TR*spbk4k1
      t11 = t11*t11
      t12 = t10*t11
      t13 = mB*c2*i_
      t14 = t13*spak1k2
      t15 = t14*spak3k4
      t11 = t11*t15
      abb3n2 = ((4.0_ki)*(t12/t5-t11/t1))
      abb3n3 = ((4.0_ki)*(t12/t6-t11/t9))
      t11 = t8*spak2k3
      t12 = t11*spbk4k1
      t26 = TR*TR
      t16 = t26*t12/t6*spbl6k1
      t17 = t26*t12/t5*spbl5k1
      t18 = t14*spak2k3
      t19 = t18*spbk4k1
      t20 = t26*t19/t9*spbl6k1
      t21 = t26*t19/t1*spbl5k1
      t22 = t16+t17-(t21+t20)
      abb3n4 = ((8.0_ki)*t22)
      abb3n5 = ((4.0_ki)*t22)
      t11 = t11*spbk3k1
      t22 = t8*spak2k4*spbk4k1
      t18 = t18*spbk3k1
      t23 = t14*spak2k4*spbk4k1
      abb3n6 = ((4.0_ki)*(t26*t18/t1*spbl5k1+t26*t23/t1*spbl5k1+t26*t18/t9*spbl6&
      &k1+t26*t23/t9*spbl6k1-(t26*t22/t6*spbl6k1+t26*t22/t5*spbl5k1+t26*t11/t6*s&
      &pbl6k1+t26*t11/t5*spbl5k1)))
      t11 = t3*spak2k3
      t18 = t26*t11*spbk4k1
      t22 = t13*spak2k3
      t23 = t26*t22*spbk4k1
      abb3n7 = ((8.0_ki)*(t23/t1-t18/t5))
      abb3n8 = ((8.0_ki)*(t23/t9-t18/t6))
      t18 = t26*t11*spbk2k1
      t23 = t26*t3*spak3k4*spbk4k1
      t24 = t26*t22*spbk2k1
      t25 = t26*t13*spak3k4*spbk4k1
      abb3n9 = ((4.0_ki)*(t18/t5+t23/t5-(t25/t1+t24/t1)))
      abb3n10 = ((4.0_ki)*(t18/t6+t23/t6-(t25/t9+t24/t9)))
      t18 = t3*spbk4k3
      t23 = t13*spbk4k3
      abb3n11 = ((8.0_ki)*(t20+t21+t18*t4/t5*spbl5k1+t18*t4/t6*spbl6k1-(t23*t4/t&
      &9*spbl6k1+t23/t1*t4*spbl5k1+t17+t16)))
      t16 = t26*t11/t6*spbl6k1
      t17 = t26*t11/t5*spbl5k1
      t20 = t26*t22/t9*spbl6k1
      t21 = t26*t22/t1*spbl5k1
      t24 = t16+t17-(t21+t20)
      abb3n12 = ((8.0_ki)*t24)
      abb3n13 = ((4.0_ki)*t24)
      t16 = t20+t21-(t17+t16)
      abb3n14 = ((4.0_ki)*t16)
      abb3n15 = ((8.0_ki)*t16)
      t16 = t3*spak2k4
      t17 = t13*spak2k4
      abb3n16 = ((4.0_ki)*(t26*t17/t1*spbl5k1+t26*t17/t9*spbl6k1-(t26*t16/t6*spb&
      &l6k1+t26*t16/t5*spbl5k1)))
      t2 = t2*spak2k3
      t7 = t7*spak2k3
      t10 = t10*spbk4k1
      t15 = t15*spbk4k1
      abb3n17 = ((4.0_ki)*(t23/t1*t4*spbl5k2+t26/t1*t7*spbl5k4+t26*t10/t5*spbl5k&
      &4+t26*t10/t6*spbl6k4+t26*t12/t5*spbl5k2+t26*t12/t6*spbl6k2+t23*t4/t9*spbl&
      &6k2+t26*t7/t9*spbl6k4-(t26*t2/t6*spbl6k4+t26*t2/t5*spbl5k4+t26*t19/t9*spb&
      &l6k2+t18*t4/t6*spbl6k2+t18*t4/t5*spbl5k2+t26*t15/t9*spbl6k4+t26*t19/t1*sp&
      &bl5k2+t26*t15/t1*spbl5k4)))
      t2 = t26*t11*spbk4k2
      t4 = t26*t22*spbk4k2
      abb3n18 = ((8.0_ki)*(t2/t5-t4/t1))
      abb3n19 = ((8.0_ki)*(t2/t6-t4/t9))
      t2 = t26*t11/t6*spbl6k4
      t4 = t26*t11/t5*spbl5k4
      t7 = t26*t22/t9*spbl6k4
      t10 = t26*t22/t1*spbl5k4
      abb3n20 = ((8.0_ki)*(t2+t4-(t7+t10)))
      t2 = t10+t7-(t4+t2)
      abb3n21 = ((4.0_ki)*t2)
      abb3n22 = ((8.0_ki)*t2)
      abb3n23 = ((4.0_ki)*(t26*t14/t1*spbl5k1+t26*t11/t5*spbl5k3+t26*t11/t6*spbl&
      &6k3+t26*t14/t9*spbl6k1+t26*t16/t5*spbl5k4+t26*t16/t6*spbl6k4-(t26/t6*t8*s&
      &pbl6k1+t26/t5*t8*spbl5k1+t26*t22/t9*spbl6k3+t26*t17/t9*spbl6k4+t26*t22/t1&
      &*spbl5k3+t26*t17/t1*spbl5k4)))
      t2 = t26*t3
      t3 = t26*t13
      abb3n24 = ((4.0_ki)*(t3/t1-t2/t5))
      abb3n25 = ((4.0_ki)*(t3/t9-t2/t6))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n27 = abb3n1
      abb3n28 = abb3n23
      abb3n29 = abb3n22
      abb3n30 = abb3n20
      abb3n31 = abb3n19
      abb3n32 = abb3n18
      abb3n33 = abb3n16
      abb3n34 = abb3n15
      abb3n35 = abb3n14
      abb3n36 = abb3n12
      abb3n37 = abb3n10
      abb3n38 = abb3n9
      abb3n39 = abb3n8
      abb3n40 = abb3n7
      abb3n41 = abb3n5
      abb3n42 = -(abb3n2)
      abb3n43 = -(abb3n3)
      abb3n44 = -(abb3n4)
      abb3n45 = ((2.0_ki)*abb3n5)
      abb3n46 = -(abb3n6)
      abb3n47 = -(abb3n11)
      abb3n48 = -(abb3n13)
      abb3n49 = (-2.0_ki)*abb3n13
      abb3n50 = -(abb3n17)
      abb3n51 = -(abb3n21)
      abb3n52 = (-2.0_ki)*abb3n21
      abb3n53 = -(abb3n24)
      abb3n54 = -(abb3n25)
   end subroutine
end module p0_udbar_neepbbbar_abbrevd3h3
