module     p0_udbar_neepbbbar_d2h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity3/d2h3l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d2
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd2h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t34 = dotproduct(qshift, qshift)
      t2 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      t3 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t35 = dotproduct(k1, qshift)
      t36 = dotproduct(k3, qshift)
      t37 = dotproduct(k4, qshift)
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb2n27+t2*abb2n53+t3*abb2n54+t34*abb2n34+t35*abb2n55+t&
         &36*abb2n56+t37*abb2n56+t4*abb2n59+t1*t2*abb2n38+t1*t3*abb2n37+t1*t5*ab&
         &b2n30+t2*t35*abb2n41+t2*t36*abb2n42+t2*t37*abb2n42+t2*t4*abb2n47+t2*t5&
         &*abb2n44+t2*t6*abb2n36+t3*t35*abb2n39+t3*t36*abb2n40+t3*t37*abb2n40+t3&
         &*t4*abb2n46+t3*t5*abb2n43+t3*t6*abb2n35+t34*t5*abb2n73+t35*t5*abb2n31+&
         &t36*t5*abb2n33+t37*t5*abb2n33+t1*t2*t5*abb2n77+t1*t3*t5*abb2n78)
         return
      end if
      t7 = k1(iv1)
      t8 = k3(iv1)
      t9 = k4(iv1)
      t10 = qshift(iv1)
      t11 = spvak2l5(iv1)
      t12 = spvak2l6(iv1)
      t13 = spvak3k1(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak2k1(iv1)
      t16 = t15*abb2n71
      t17 = spvak2k4(iv1)
      t18 = t11*abb2n62
      t19 = t12*abb2n64
      if(deg.eq.1) then
         numerator = (t10*abb2n70+t11*abb2n51+t12*abb2n50+t13*abb2n45+t14*abb2n5&
         &2+t16*t36+t16*t37+t18*t36+t18*t37+t19*t36+t19*t37+t7*abb2n49+t8*abb2n4&
         &8+t9*abb2n48+t1*t11*abb2n66+t1*t12*abb2n67+t1*t15*abb2n76+t10*t5*abb2n&
         &72+t11*t35*abb2n63+t11*t4*abb2n57+t11*t5*abb2n60+t11*t6*abb2n68+t12*t3&
         &5*abb2n65+t12*t4*abb2n58+t12*t5*abb2n61+t12*t6*abb2n69+t13*t2*abb2n57+&
         &t13*t3*abb2n58+t14*t2*abb2n66+t14*t3*abb2n67+t14*t5*abb2n76+t15*t2*abb&
         &2n60+t15*t3*abb2n61+t15*t34*abb2n32+t15*t35*abb2n75+t17*t2*abb2n68+t17&
         &*t3*abb2n69+t2*t7*abb2n63+t2*t8*abb2n62+t2*t9*abb2n62+t3*t7*abb2n65+t3&
         &*t8*abb2n64+t3*t9*abb2n64+t5*t7*abb2n75+t5*t8*abb2n71+t5*t9*abb2n71+t1&
         &*t11*t5*abb2n29+t1*t12*t5*abb2n28+t1*t15*t2*abb2n29+t1*t15*t3*abb2n28+&
         &t14*t2*t5*abb2n29+t14*t3*t5*abb2n28)
         return
      end if
      t34 = d(iv1,iv2)
      t4 = spvak2k1(iv2)
      t6 = spvak2l5(iv2)
      t16 = spvak2l6(iv2)
      t18 = k1(iv2)
      t19 = k3(iv2)
      t20 = k4(iv2)
      t21 = t15*t6
      t22 = t15*t16
      t23 = spvak3k4(iv2)
      t24 = t15*t23
      t25 = t11*t4
      t26 = t12*t4
      t27 = t14*t4
      t28 = spvak2k4(iv2)
      t29 = spvak3k1(iv2)
      t30 = t11*t23
      t31 = t14*t6
      t32 = t12*t23
      t33 = t14*t16
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb2n34+t34*t5*abb2n73)+t21*abb2n44+t22*abb2&
         &n43+t24*abb2n30+t25*abb2n44+t26*abb2n43+t27*abb2n30+t30*abb2n38+t31*ab&
         &b2n38+t32*abb2n37+t33*abb2n37+qshift(iv2)*t15*abb2n74+t1*t21*abb2n77+t&
         &1*t22*abb2n78+t1*t25*abb2n77+t1*t26*abb2n78+t10*t4*abb2n74+t11*t18*abb&
         &2n41+t11*t19*abb2n42+t11*t20*abb2n42+t11*t28*abb2n36+t11*t29*abb2n47+t&
         &12*t18*abb2n39+t12*t19*abb2n40+t12*t20*abb2n40+t12*t28*abb2n35+t12*t29&
         &*abb2n46+t13*t16*abb2n46+t13*t6*abb2n47+t15*t18*abb2n31+t15*t19*abb2n3&
         &3+t15*t20*abb2n33+t16*t17*abb2n35+t16*t7*abb2n39+t16*t8*abb2n40+t16*t9&
         &*abb2n40+t17*t6*abb2n36+t2*t24*abb2n77+t2*t27*abb2n77+t24*t3*abb2n78+t&
         &27*t3*abb2n78+t30*t5*abb2n77+t31*t5*abb2n77+t32*t5*abb2n78+t33*t5*abb2&
         &n78+t4*t7*abb2n31+t4*t8*abb2n33+t4*t9*abb2n33+t6*t7*abb2n41+t6*t8*abb2&
         &n42+t6*t9*abb2n42)
         return
      end if
      t1 = spvak2k1(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2l5(iv3)
      t5 = spvak2l6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t4*abb2n32+d(iv2,iv3)*t15*abb2n32+t1*&
         &t34*abb2n32)+t2*t21*abb2n29+t2*t22*abb2n28+t2*t25*abb2n29+t2*t26*abb2n&
         &28+t1*t11*t23*abb2n29+t1*t12*t23*abb2n28+t1*t14*t16*abb2n28+t1*t14*t6*&
         &abb2n29+t14*t3*t4*abb2n29+t14*t4*t5*abb2n28+t15*t23*t3*abb2n29+t15*t23&
         &*t5*abb2n28)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d2:
   subroutine     reconstruct_d2(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_2:
      coeffs%coeffs_2%c0 = derivative(czip)
      coeffs%coeffs_2%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_2%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_2%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_2%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_2%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_2%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_2%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_2%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_2%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_2%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_2%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_2%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_2%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_2%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_2%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_2%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_2%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_2%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_2%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_2%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_2%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_2%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_2%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_2%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_2%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_2%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_2%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_2%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_2:
   end subroutine reconstruct_d2
!---#] subroutine reconstruct_d2:
end module p0_udbar_neepbbbar_d2h3l1d
