module     p0_udbar_neepbbbar_d28h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity1/d28h1l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d28
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd28h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      real(ki) :: t14
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3l5(1)*qshift(1)-spvak3l5(2)*qshift(2)-spvak3l5(3)*qshift(3)-sp&
      &vak3l5(4)*qshift(4))
      t14 = dotproduct(k2, qshift)
      t2 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      t3 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-sp&
      &val6l5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb28n16+t1*abb28n30+t14*abb28n31+t2*abb28n32+t3*abb28n33+&
         &t4*abb28n34+t5*abb28n41+abb28n35*dotproduct(l5, qshift)+t1*t3*abb28n19&
         &+t14*t4*abb28n17+t14*t5*abb28n21+t2*t3*abb28n23+t4*t6*abb28n20+t5*t6*a&
         &bb28n22)
         return
      end if
      t7 = k2(iv1)
      t8 = spvak2k1(iv1)
      t9 = spvak2l5(iv1)
      t10 = spvak3k1(iv1)
      t11 = spvak3l5(iv1)
      t12 = spval6k1(iv1)
      t13 = spval6l5(iv1)
      if(deg.eq.1) then
         numerator = (l5(iv1)*abb28n24+t10*abb28n25+t11*abb28n29+t12*abb28n26+t7&
         &*abb28n28+t8*abb28n18+t9*abb28n27+t1*t12*abb28n40+t10*t14*abb28n42+t10&
         &*t6*abb28n39+t11*t3*abb28n40+t12*t2*abb28n36+t13*t4*abb28n39+t13*t5*ab&
         &b28n37+t14*t8*abb28n38+t3*t9*abb28n36+t4*t7*abb28n42+t5*t7*abb28n38+t6&
         &*t8*abb28n37)
         return
      end if
      t1 = spvak2k1(iv2)
      t2 = spvak3k1(iv2)
      t3 = k2(iv2)
      t4 = spval6l5(iv2)
      t5 = spval6k1(iv2)
      if(deg.eq.2) then
         numerator = (spvak2l5(iv2)*t12*abb28n23+spvak3l5(iv2)*t12*abb28n19+t1*t&
         &13*abb28n22+t1*t7*abb28n21+t10*t3*abb28n17+t10*t4*abb28n20+t11*t5*abb2&
         &8n19+t13*t2*abb28n20+t2*t7*abb28n17+t3*t8*abb28n21+t4*t8*abb28n22+t5*t&
         &9*abb28n23)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d28:
   subroutine     reconstruct_d28(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_28:
      coeffs%coeffs_28%c0 = derivative(czip)
      coeffs%coeffs_28%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_28%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_28%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_28%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_28%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_28%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_28%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_28%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_28%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_28%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_28%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_28%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_28%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_28:
   end subroutine reconstruct_d28
!---#] subroutine reconstruct_d28:
end module p0_udbar_neepbbbar_d28h1l1d
