module     p0_udbar_neepbbbar_d3h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity2/d3h2l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd3h2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t37 = dotproduct(qshift, qshift)
      t38 = dotproduct(k2, qshift)
      t1 = (spval5l6(1)*qshift(1)-spval5l6(2)*qshift(2)-spval5l6(3)*qshift(3)-sp&
      &val5l6(4)*qshift(4))
      t39 = dotproduct(k3, qshift)
      t40 = dotproduct(k4, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t7 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t8 = (spvak2k3(1)*qshift(1)-spvak2k3(2)*qshift(2)-spvak2k3(3)*qshift(3)-sp&
      &vak2k3(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n36+t1*abb3n56+t2*abb3n58+t3*abb3n66+t37*abb3n53+t38*a&
         &bb3n61+t38*t38*abb3n54+t39*abb3n57+t4*abb3n67+t40*abb3n57+t5*abb3n70+t&
         &1*t38*abb3n55+t1*t4*abb3n46+t1*t7*abb3n52+t2*t3*abb3n42+t2*t37*abb3n62&
         &+t2*t38*abb3n51+t2*t4*abb3n41+t2*t5*abb3n40+t2*t6*abb3n38+t2*t7*abb3n4&
         &7+t2*t8*abb3n49+t3*t37*abb3n71+t3*t38*abb3n44+t3*t39*abb3n43+t3*t40*ab&
         &b3n43+t37*t4*abb3n68+t37*t5*abb3n73+t37*t7*abb3n64+t38*t4*abb3n45+t38*&
         &t5*abb3n37+t38*t7*abb3n50+t39*t4*abb3n45+t39*t5*abb3n39+t39*t7*abb3n48&
         &+t4*t40*abb3n45+t40*t5*abb3n39+t40*t7*abb3n48+t1*t2*t4*abb3n75+t2*t38*&
         &t4*abb3n76)
         return
      end if
      t9 = k2(iv1)
      t10 = k3(iv1)
      t11 = k4(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k4(iv1)
      t16 = spval5k1(iv1)
      t17 = spval5l6(iv1)
      t18 = t13*abb3n45
      t19 = spvak2k3(iv1)
      t20 = spvak2k4(iv1)
      t21 = t20*abb3n48
      t22 = t14*abb3n39
      t23 = spvak4k1(iv1)
      t24 = t16*abb3n43
      if(deg.eq.1) then
         numerator = (t10*abb3n57+t11*abb3n57+t12*abb3n60+t13*abb3n67+t14*abb3n7&
         &0+t15*abb3n58+t16*abb3n66+t17*abb3n56+t18*t38+t18*t39+t18*t40+t21*t39+&
         &t21*t40+t22*t39+t22*t40+t24*t39+t24*t40+t9*abb3n61+t1*t13*abb3n46+t1*t&
         &20*abb3n52+t1*t9*abb3n55+t10*t3*abb3n43+t10*t4*abb3n45+t10*t5*abb3n39+&
         &t10*t7*abb3n48+t11*t3*abb3n43+t11*t4*abb3n45+t11*t5*abb3n39+t11*t7*abb&
         &3n48+t12*t2*abb3n63+t12*t3*abb3n72+t12*t4*abb3n69+t12*t5*abb3n74+t12*t&
         &7*abb3n65+t13*t2*abb3n41+t13*t37*abb3n68+t14*t2*abb3n40+t14*t37*abb3n7&
         &3+t14*t38*abb3n37+t15*t3*abb3n42+t15*t37*abb3n62+t15*t38*abb3n51+t15*t&
         &4*abb3n41+t15*t5*abb3n40+t15*t6*abb3n38+t15*t7*abb3n47+t15*t8*abb3n49+&
         &t16*t2*abb3n42+t16*t37*abb3n71+t16*t38*abb3n44+t17*t38*abb3n55+t17*t4*&
         &abb3n46+t17*t7*abb3n52+t19*t2*abb3n49+t2*t20*abb3n47+t2*t23*abb3n38+t2&
         &*t9*abb3n51+t20*t37*abb3n64+t20*t38*abb3n50+t3*t9*abb3n44+t38*t9*abb3n&
         &59+t4*t9*abb3n45+t5*t9*abb3n37+t7*t9*abb3n50+t1*t13*t2*abb3n75+t1*t15*&
         &t4*abb3n75+t13*t2*t38*abb3n76+t15*t38*t4*abb3n76+t17*t2*t4*abb3n75+t2*&
         &t4*t9*abb3n76)
         return
      end if
      t37 = d(iv1,iv2)
      t6 = k2(iv2)
      t8 = spvak2k1(iv2)
      t18 = t8*t9
      t21 = spvak2k4(iv2)
      t22 = spvak3k1(iv2)
      t24 = spvak3k4(iv2)
      t25 = t24*t9
      t26 = spval5k1(iv2)
      t27 = spval5l6(iv2)
      t28 = t13*t6
      t29 = t15*t6
      t30 = k3(iv2)
      t31 = k4(iv2)
      t32 = qshift(iv2)
      t33 = t13*t24
      t34 = t13*t27
      t35 = t15*t8
      t36 = t17*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t37*abb3n53+t2*t37*abb3n62+t3*t37*abb3n71+t37*t4&
         &*abb3n68+t37*t5*abb3n73+t37*t7*abb3n64+t6*t9*abb3n54)+t18*abb3n45+t25*&
         &abb3n51+t28*abb3n45+t29*abb3n51+t33*abb3n41+t34*abb3n46+t35*abb3n41+t3&
         &6*abb3n46+spvak2k3(iv2)*t15*abb3n49+spvak4k1(iv2)*t15*abb3n38+t1*t33*a&
         &bb3n75+t1*t35*abb3n75+t10*t21*abb3n48+t10*t22*abb3n39+t10*t26*abb3n43+&
         &t10*t8*abb3n45+t11*t21*abb3n48+t11*t22*abb3n39+t11*t26*abb3n43+t11*t8*&
         &abb3n45+t12*t21*abb3n65+t12*t22*abb3n74+t12*t24*abb3n63+t12*t26*abb3n7&
         &2+t12*t8*abb3n69+t13*t30*abb3n45+t13*t31*abb3n45+t13*t32*abb3n69+t14*t&
         &24*abb3n40+t14*t30*abb3n39+t14*t31*abb3n39+t14*t32*abb3n74+t14*t6*abb3&
         &n37+t15*t21*abb3n47+t15*t22*abb3n40+t15*t26*abb3n42+t15*t32*abb3n63+t1&
         &6*t24*abb3n42+t16*t30*abb3n43+t16*t31*abb3n43+t16*t32*abb3n72+t16*t6*a&
         &bb3n44+t17*t21*abb3n52+t17*t6*abb3n55+t18*t2*abb3n76+t19*t24*abb3n49+t&
         &2*t28*abb3n76+t2*t34*abb3n75+t2*t36*abb3n75+t20*t24*abb3n47+t20*t27*ab&
         &b3n52+t20*t30*abb3n48+t20*t31*abb3n48+t20*t32*abb3n65+t20*t6*abb3n50+t&
         &21*t9*abb3n50+t22*t9*abb3n37+t23*t24*abb3n38+t25*t4*abb3n76+t26*t9*abb&
         &3n44+t27*t9*abb3n55+t29*t4*abb3n76+t33*t38*abb3n76+t35*t38*abb3n76+t15&
         &*t27*t4*abb3n75+t17*t24*t4*abb3n75)
         return
      end if
      t38 = d(iv2,iv3)
      t39 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak3k4(iv3)
      t3 = k2(iv3)
      t4 = spval5l6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t37*abb3n64+spvak3k1(iv3)*t37*abb3&
         &n73+spval5k1(iv3)*t37*abb3n71+t1*t37*abb3n68+t13*t38*abb3n68+t14*t38*a&
         &bb3n73+t15*t38*abb3n62+t16*t38*abb3n71+t2*t37*abb3n62+t20*t38*abb3n64+&
         &t21*t39*abb3n64+t22*t39*abb3n73+t24*t39*abb3n62+t26*t39*abb3n71+t39*t8&
         &*abb3n68)+t18*t2*abb3n76+t2*t28*abb3n76+t33*t4*abb3n75+t35*t4*abb3n75+&
         &t1*t15*t27*abb3n75+t1*t15*t6*abb3n76+t1*t17*t24*abb3n75+t1*t24*t9*abb3&
         &n76+t13*t2*t27*abb3n75+t13*t24*t3*abb3n76+t15*t3*t8*abb3n76+t17*t2*t8*&
         &abb3n75)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p0_udbar_neepbbbar_d3h2l1d
