module     p0_udbar_neepbbbar_diagramsh3l0fr5
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity3/diagramsl0fr5.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_color, only: numcs
   use p0_udbar_neepbbbar_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p0_udbar_neepbbbar_model
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_color
      use p0_udbar_neepbbbar_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p0_udbar_neepbbbar_accu, only: sorted_sum
      use p0_udbar_neepbbbar_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(2,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t1 = es34+i_*mW*wW-mW*mW
      t2 = spbk4k3*spbl6k1
      t3 = t1*es234*es56
      t4 = spbk4k3*spbl5k1
      t1 = t1*NC*es234*es56
      diagrams(2, :) = (spak2k3*spak2k3*mB*i_*TR*(4.0_ki)*((t2/(t1*spak2l5)+t4/(&
      &t1*spak2l6))*c1+(-(t4/(t3*spak2l6)+t2/(t3*spak2l5)))*c2))
      diagrams(1, :) = (0.0_ki)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 3, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 3, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p0_udbar_neepbbbar_diagramsh3l0fr5
